ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC vs.
Revision 1.44 by root, Tue Jun 14 07:04:43 2011 UTC

7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
41 44
42# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
43# required by mkbundle 46# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 48
46# which extra modules you might want to install 49# which extra modules you might want to install
47EXTRA_MODULES="" 50EXTRA_MODULES=""
48 51
49# overridable functions 52# overridable functions
50preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
51postconfigure() { : ; } 55postconfigure() { : ; }
52postbuild() { : ; } 56postbuild() { : ; }
53postinstall() { : ; } 57postinstall() { : ; }
54 58
55# now source user config, if any 59# now source user config, if any
62fi 66fi
63 67
64############################################################################# 68#############################################################################
65# support 69# support
66 70
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 72
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
72 80
73# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
75$VERSION=0.912 83$VERSION="1.31"
76 84
77BZ2=bz2 85BZ2=bz2
78BZIP2=bzip2 86BZIP2=bzip2
79 87
80fatal() { 88fatal() {
148 verblock <<EOF 156 verblock <<EOF
149downloading perl 157downloading perl
150to manually download perl yourself, place 158to manually download perl yourself, place
151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
152trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
153EOF 164EOF
154 165
155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
158 || fatal "$URL: unable to download" 169 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2 170 rm -f perl-$PERL_VERSION.tar.$BZ2
160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 171 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
161 fi 172 fi
162 173
164unpacking perl 175unpacking perl
165EOF 176EOF
166 177
167 mkdir -p unpack 178 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION 179 rm -rf unpack/perl-$PERL_VERSION
169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION 182 chmod -R u+w unpack/perl-$PERL_VERSION
172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
173 rmdir -p unpack 184 rmdir -p unpack
174 fi 185 fi
175} 186}
226 237
227 # I hate them for this 238 # I hate them for this
228 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230 241
231 preconfigure 242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
232 247
233# trace configure \ 248# trace configure \
234 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
235 -Uuse64bitint \ 250 -Uuse64bitint \
236 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
238 -Uusethreads \ 253 -Uusethreads \
239 -Uuseithreads \ 254 -Uuseithreads \
240 -Uusemultiplicity \ 255 -Uusemultiplicity \
241 -Uusesfio \ 256 -Uusesfio \
242 -Uuseshrplib \ 257 -Uuseshrplib \
258 -Uinstallusrbinperl \
243 -A ccflags=" $PERL_CCFLAGS" \ 259 -A ccflags=" $PERL_CCFLAGS" \
244 -Dcc="$PERL_CC" \ 260 -Dcc="$PERL_CC" \
245 -Doptimize="$PERL_OPTIMIZE" \ 261 -Doptimize="$PERL_OPTIMIZE" \
246 -Dldflags="$PERL_LDFLAGS" \ 262 -Dldflags="$PERL_LDFLAGS" \
247 -Dlibs="$PERL_LIBS" \ 263 -Dlibs="$PERL_LIBS" \
267 sedreplace ' 283 sedreplace '
268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
269 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
270 ' config.sh 286 ' config.sh
271 287
288 patchconfig || fatal "patchconfig hook failed"
289
272 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
273 291
274 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
275 293
276 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
277} 306}
278 307
279build() { 308build() {
280 configure 309 configure
281 310
302EOF 331EOF
303 332
304 ln -sf "perl/bin/" "$STATICPERL/bin" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
305 ln -sf "perl/lib/" "$STATICPERL/lib" 334 ln -sf "perl/lib/" "$STATICPERL/lib"
306 335
336 mkdir "$STATICPERL/patched"
337
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf 339 rm -rf "$PERL_PREFIX" # by this rm -rf
309 340
310 "$MAKE" install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
311 342
312 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
313 344
314 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
316"$MAKE" || exit 347#CAT make-install-make.sh
317
318if find blib/arch/auto -type f | grep -q -v .exists; then
319 echo Probably an XS module, rebuilding perl
320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
322 && rm -f "$PERL_PREFIX"/bin/perl \
323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
329fi
330
331"$MAKE" install UNINST=1
332EOF 348EOF
333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
334 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
335 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
337 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
338 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
341 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
350 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
351 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
352 378
353 touch "$PERL_PREFIX/staticstamp.install" 379 touch "$PERL_PREFIX/staticstamp.install"
354 fi 380 fi
374installing modules from CPAN 400installing modules from CPAN
375$@ 401$@
376EOF 402EOF
377 403
378 for mod in "$@"; do 404 for mod in "$@"; do
379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
380 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
381 done 407 done
382 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
383} 409}
384 410
400 rcd $mod 426 rcd $mod
401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
402 "$MAKE" distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
404 "$MAKE" || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
406 "$MAKE" distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
407 exit 0 433 exit 0
408 ) || exit $? 434 ) || exit $?
409 done 435 done
410} 436}
442#CAT mkbundle 468#CAT mkbundle
443MKBUNDLE 469MKBUNDLE
444} 470}
445 471
446bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache" 476 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE" 477 mkdir -p "$CACHE"
451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
470 ;; 497 ;;
471 instcpan ) 498 instcpan )
472 ( instcpan "$@" ) || exit 499 ( instcpan "$@" ) || exit
473 exit 500 exit
474 ;; 501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
505 exit
506 ;;
475 cpan ) 507 cpan )
476 ( install ) || exit 508 ( install ) || exit
477 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
478 exit 510 exit
479 ;; 511 ;;
480 mkbundle ) 512 mkbundle )
481 ( install ) || exit 513 ( install ) || exit
482 bundle "$@" 514 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines